from interp.grid.delaunay import dgrid as basegrid
from interp.tools import baker_exact_2D as exact_func

from itertools import product

import numpy as np

class rect_grid(basegrid):
  def __init__(self, xres = 5, yres = 5):
    xmin =  0.0
    xmax =  1.0
    xspan = xmax - xmin
    xdel = xspan / float(xres - 1)

    ymin =  0.0
    ymay =  1.0
    yspan = ymay - ymin
    ydel = yspan / float(yres - 1)


    verts = []
    q     = np.zeros( xres * yres )
    for x in xrange(xres):
      cur_x = xmin + (x * xdel)
      for y in xrange(yres):
        cur_y = ymin + (y * ydel)
        verts.append([cur_x, cur_y])

    basegrid.__init__(self, verts, q)


class random_grid(rect_grid):
  def __init__(self, num_verts = 10):

    appx_side_res = int(np.sqrt(num_verts))
    delta = 1.0 / float(appx_side_res)

    # load up corners:
    verts = [i for i in product((0,1), repeat = 2)]

    for x in xrange(1,appx_side_res):
      cur_x = x * delta
      for cur_y in (0, 1):
        new_point = [cur_x, cur_y]
        verts.append(new_point)

    for y in xrange(1,appx_side_res):
      cur_y = y * delta
      for cur_x in (0, 1):
        new_point = [cur_x, cur_y]
        verts.append(new_point)

    verts.extend(np.random.random((num_verts - 4*appx_side_res, 2)))

    q = np.zeros(len(verts))
    basegrid.__init__(self, np.array(verts), q)
